
_I2C_LCD_Cmd:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;LCD2x16_I2C.c,5 :: 		void I2C_LCD_Cmd(char out_char) {
;LCD2x16_I2C.c,8 :: 		char rs = 0x00;
	LDI        R27, 0
	STD        Y+2, R27
;LCD2x16_I2C.c,10 :: 		hi_n = out_char & 0xF0;
	MOV        R16, R2
	ANDI       R16, 240
	STD        Y+0, R16
;LCD2x16_I2C.c,11 :: 		lo_n = (out_char << 4) & 0xF0;
	MOV        R16, R2
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
	STD        Y+1, R16
;LCD2x16_I2C.c,13 :: 		TWI_Start();
	PUSH       R2
	CALL       _TWI_Start+0
;LCD2x16_I2C.c,14 :: 		TWI_Write(LCD_ADDR);
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,15 :: 		TWI_Write(hi_n | rs | 0x04 | 0x08);
	LDD        R17, Y+0
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,16 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Cmd0:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd0
	DEC        R17
	BRNE       L_I2C_LCD_Cmd0
;LCD2x16_I2C.c,17 :: 		TWI_Write(hi_n | rs | 0x00 | 0x08);
	LDD        R17, Y+0
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,18 :: 		Delay_us(100);
	LDI        R17, 3
	LDI        R16, 19
L_I2C_LCD_Cmd2:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd2
	DEC        R17
	BRNE       L_I2C_LCD_Cmd2
;LCD2x16_I2C.c,19 :: 		TWI_Write(lo_n | rs | 0x04 | 0x08);
	LDD        R17, Y+1
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,20 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Cmd4:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd4
	DEC        R17
	BRNE       L_I2C_LCD_Cmd4
;LCD2x16_I2C.c,21 :: 		TWI_Write(lo_n | rs | 0x00 | 0x08);
	LDD        R17, Y+1
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
	POP        R2
;LCD2x16_I2C.c,22 :: 		TWI_stop();
	CALL       _TWI_Stop+0
;LCD2x16_I2C.c,24 :: 		if(out_char == 0x01)Delay_ms(2);
	LDI        R27, 1
	CP         R2, R27
	BREQ       L__I2C_LCD_Cmd50
	JMP        L_I2C_LCD_Cmd6
L__I2C_LCD_Cmd50:
	LDI        R17, 42
	LDI        R16, 142
L_I2C_LCD_Cmd7:
	DEC        R16
	BRNE       L_I2C_LCD_Cmd7
	DEC        R17
	BRNE       L_I2C_LCD_Cmd7
	NOP
L_I2C_LCD_Cmd6:
;LCD2x16_I2C.c,25 :: 		}
L_end_I2C_LCD_Cmd:
	ADIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Cmd

_I2C_LCD_Chr:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;LCD2x16_I2C.c,27 :: 		void I2C_LCD_Chr(char row, char column, char out_char) {
;LCD2x16_I2C.c,30 :: 		char rs = 0x01;
	PUSH       R2
	LDI        R27, 1
	STD        Y+2, R27
;LCD2x16_I2C.c,32 :: 		switch(row){
	JMP        L_I2C_LCD_Chr9
;LCD2x16_I2C.c,34 :: 		case 1:
L_I2C_LCD_Chr11:
;LCD2x16_I2C.c,35 :: 		I2C_LCD_Cmd(0x80 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 128
	PUSH       R4
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	POP        R4
;LCD2x16_I2C.c,36 :: 		break;
	JMP        L_I2C_LCD_Chr10
;LCD2x16_I2C.c,37 :: 		case 2:
L_I2C_LCD_Chr12:
;LCD2x16_I2C.c,38 :: 		I2C_LCD_Cmd(0xC0 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 64
	PUSH       R4
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	POP        R4
;LCD2x16_I2C.c,39 :: 		break;
	JMP        L_I2C_LCD_Chr10
;LCD2x16_I2C.c,40 :: 		case 3:
L_I2C_LCD_Chr13:
;LCD2x16_I2C.c,41 :: 		I2C_LCD_Cmd(0x94 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 108
	PUSH       R4
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	POP        R4
;LCD2x16_I2C.c,42 :: 		break;
	JMP        L_I2C_LCD_Chr10
;LCD2x16_I2C.c,43 :: 		case 4:
L_I2C_LCD_Chr14:
;LCD2x16_I2C.c,44 :: 		I2C_LCD_Cmd(0xD4 + (column - 1));
	MOV        R16, R3
	SUBI       R16, 1
	SUBI       R16, 44
	PUSH       R4
	MOV        R2, R16
	CALL       _I2C_LCD_Cmd+0
	POP        R4
;LCD2x16_I2C.c,45 :: 		break;
	JMP        L_I2C_LCD_Chr10
;LCD2x16_I2C.c,46 :: 		};
L_I2C_LCD_Chr9:
	LDI        R27, 1
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr52
	JMP        L_I2C_LCD_Chr11
L__I2C_LCD_Chr52:
	LDI        R27, 2
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr53
	JMP        L_I2C_LCD_Chr12
L__I2C_LCD_Chr53:
	LDI        R27, 3
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr54
	JMP        L_I2C_LCD_Chr13
L__I2C_LCD_Chr54:
	LDI        R27, 4
	CP         R2, R27
	BRNE       L__I2C_LCD_Chr55
	JMP        L_I2C_LCD_Chr14
L__I2C_LCD_Chr55:
L_I2C_LCD_Chr10:
;LCD2x16_I2C.c,48 :: 		hi_n = out_char & 0xF0;
	MOV        R16, R4
	ANDI       R16, 240
	STD        Y+0, R16
;LCD2x16_I2C.c,49 :: 		lo_n = (out_char << 4) & 0xF0;
	MOV        R16, R4
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
	STD        Y+1, R16
;LCD2x16_I2C.c,51 :: 		TWI_Start();
	CALL       _TWI_Start+0
;LCD2x16_I2C.c,52 :: 		TWI_Write(LCD_ADDR);
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,53 :: 		TWI_Write(hi_n | rs | 0x04 | 0x08);
	LDD        R17, Y+0
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,54 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Chr15:
	DEC        R16
	BRNE       L_I2C_LCD_Chr15
	DEC        R17
	BRNE       L_I2C_LCD_Chr15
;LCD2x16_I2C.c,55 :: 		TWI_Write(hi_n | rs | 0x00 | 0x08);
	LDD        R17, Y+0
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,56 :: 		Delay_us(100);
	LDI        R17, 3
	LDI        R16, 19
L_I2C_LCD_Chr17:
	DEC        R16
	BRNE       L_I2C_LCD_Chr17
	DEC        R17
	BRNE       L_I2C_LCD_Chr17
;LCD2x16_I2C.c,57 :: 		TWI_Write(lo_n | rs | 0x04 | 0x08);
	LDD        R17, Y+1
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,58 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Chr19:
	DEC        R16
	BRNE       L_I2C_LCD_Chr19
	DEC        R17
	BRNE       L_I2C_LCD_Chr19
;LCD2x16_I2C.c,59 :: 		TWI_Write(lo_n | rs | 0x00 | 0x08);
	LDD        R17, Y+1
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,60 :: 		TWI_stop();
	CALL       _TWI_Stop+0
;LCD2x16_I2C.c,61 :: 		}
L_end_I2C_LCD_Chr:
	POP        R2
	ADIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Chr

_I2C_LCD_Chr_Cp:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 3
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;LCD2x16_I2C.c,63 :: 		void I2C_LCD_Chr_Cp(char out_char) {
;LCD2x16_I2C.c,66 :: 		char rs = 0x01;
	PUSH       R2
	LDI        R27, 1
	STD        Y+2, R27
;LCD2x16_I2C.c,68 :: 		hi_n = out_char & 0xF0;
	MOV        R16, R2
	ANDI       R16, 240
	STD        Y+0, R16
;LCD2x16_I2C.c,69 :: 		lo_n = (out_char << 4) & 0xF0;
	MOV        R16, R2
	LSL        R16
	LSL        R16
	LSL        R16
	LSL        R16
	ANDI       R16, 240
	STD        Y+1, R16
;LCD2x16_I2C.c,71 :: 		TWI_Start();
	CALL       _TWI_Start+0
;LCD2x16_I2C.c,72 :: 		TWI_Write(LCD_ADDR);
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,73 :: 		TWI_Write(hi_n | rs | 0x04 | 0x08);
	LDD        R17, Y+0
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,74 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Chr_Cp21:
	DEC        R16
	BRNE       L_I2C_LCD_Chr_Cp21
	DEC        R17
	BRNE       L_I2C_LCD_Chr_Cp21
;LCD2x16_I2C.c,75 :: 		TWI_Write(hi_n | rs | 0x00 | 0x08);
	LDD        R17, Y+0
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,76 :: 		Delay_us(100);
	LDI        R17, 3
	LDI        R16, 19
L_I2C_LCD_Chr_Cp23:
	DEC        R16
	BRNE       L_I2C_LCD_Chr_Cp23
	DEC        R17
	BRNE       L_I2C_LCD_Chr_Cp23
;LCD2x16_I2C.c,77 :: 		TWI_Write(lo_n | rs | 0x04 | 0x08);
	LDD        R17, Y+1
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,78 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Chr_Cp25:
	DEC        R16
	BRNE       L_I2C_LCD_Chr_Cp25
	DEC        R17
	BRNE       L_I2C_LCD_Chr_Cp25
;LCD2x16_I2C.c,79 :: 		TWI_Write(lo_n | rs | 0x00 | 0x08);
	LDD        R17, Y+1
	LDD        R16, Y+2
	OR         R16, R17
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,80 :: 		TWI_stop();
	CALL       _TWI_Stop+0
;LCD2x16_I2C.c,81 :: 		}
L_end_I2C_LCD_Chr_Cp:
	POP        R2
	ADIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Chr_Cp

_I2C_LCD_Init:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;LCD2x16_I2C.c,84 :: 		void I2C_LCD_Init() {
;LCD2x16_I2C.c,86 :: 		char rs = 0x00;
	PUSH       R2
	LDI        R27, 0
	STD        Y+0, R27
;LCD2x16_I2C.c,88 :: 		TWI_Start();
	CALL       _TWI_Start+0
;LCD2x16_I2C.c,89 :: 		TWI_Write(LCD_ADDR);
	LDI        R27, 78
	MOV        R2, R27
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,90 :: 		Delay_ms(30);
	LDI        R18, 3
	LDI        R17, 112
	LDI        R16, 93
L_I2C_LCD_Init27:
	DEC        R16
	BRNE       L_I2C_LCD_Init27
	DEC        R17
	BRNE       L_I2C_LCD_Init27
	DEC        R18
	BRNE       L_I2C_LCD_Init27
	NOP
;LCD2x16_I2C.c,92 :: 		TWI_Write(0x30 | rs | 0x04 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,93 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Init29:
	DEC        R16
	BRNE       L_I2C_LCD_Init29
	DEC        R17
	BRNE       L_I2C_LCD_Init29
;LCD2x16_I2C.c,94 :: 		TWI_Write(0x30 | rs | 0x00 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,95 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_I2C_LCD_Init31:
	DEC        R16
	BRNE       L_I2C_LCD_Init31
	DEC        R17
	BRNE       L_I2C_LCD_Init31
	NOP
;LCD2x16_I2C.c,97 :: 		TWI_Write(0x30 | rs | 0x04 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,98 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Init33:
	DEC        R16
	BRNE       L_I2C_LCD_Init33
	DEC        R17
	BRNE       L_I2C_LCD_Init33
;LCD2x16_I2C.c,99 :: 		TWI_Write(0x30 | rs | 0x00 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,100 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_I2C_LCD_Init35:
	DEC        R16
	BRNE       L_I2C_LCD_Init35
	DEC        R17
	BRNE       L_I2C_LCD_Init35
	NOP
;LCD2x16_I2C.c,102 :: 		TWI_Write(0x30 | rs | 0x04 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 48
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,103 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Init37:
	DEC        R16
	BRNE       L_I2C_LCD_Init37
	DEC        R17
	BRNE       L_I2C_LCD_Init37
;LCD2x16_I2C.c,104 :: 		TWI_Write(0x30 | rs | 0x00 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 48
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,105 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_I2C_LCD_Init39:
	DEC        R16
	BRNE       L_I2C_LCD_Init39
	DEC        R17
	BRNE       L_I2C_LCD_Init39
	NOP
;LCD2x16_I2C.c,107 :: 		TWI_Write(0x20 | rs | 0x04 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 32
	ORI        R16, 4
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,108 :: 		Delay_us(50);
	LDI        R17, 2
	LDI        R16, 9
L_I2C_LCD_Init41:
	DEC        R16
	BRNE       L_I2C_LCD_Init41
	DEC        R17
	BRNE       L_I2C_LCD_Init41
;LCD2x16_I2C.c,109 :: 		TWI_Write(0x20 | rs | 0x00 | 0x08);
	LDD        R16, Y+0
	ORI        R16, 32
	ORI        R16, 8
	MOV        R2, R16
	CALL       _TWI_Write+0
;LCD2x16_I2C.c,110 :: 		TWI_Stop();
	CALL       _TWI_Stop+0
;LCD2x16_I2C.c,112 :: 		Delay_ms(10);
	LDI        R17, 208
	LDI        R16, 202
L_I2C_LCD_Init43:
	DEC        R16
	BRNE       L_I2C_LCD_Init43
	DEC        R17
	BRNE       L_I2C_LCD_Init43
	NOP
;LCD2x16_I2C.c,114 :: 		I2C_LCD_Cmd(0x28);
	LDI        R27, 40
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;LCD2x16_I2C.c,115 :: 		I2C_LCD_Cmd(0x06);
	LDI        R27, 6
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;LCD2x16_I2C.c,116 :: 		}
L_end_I2C_LCD_Init:
	POP        R2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _I2C_LCD_Init

_I2C_LCD_Out:

;LCD2x16_I2C.c,118 :: 		void I2C_LCD_Out(char row, char col, char *text) {
;LCD2x16_I2C.c,119 :: 		while(*text)
L_I2C_LCD_Out45:
	MOVW       R30, R4
	LD         R16, Z
	TST        R16
	BRNE       L__I2C_LCD_Out59
	JMP        L_I2C_LCD_Out46
L__I2C_LCD_Out59:
;LCD2x16_I2C.c,120 :: 		I2C_LCD_Chr(row, col++, *text++);
	MOVW       R30, R4
	LD         R16, Z
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	MOV        R4, R16
	CALL       _I2C_LCD_Chr+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
	MOV        R16, R3
	SUBI       R16, 255
	MOV        R3, R16
	MOVW       R16, R4
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R4, R16
	JMP        L_I2C_LCD_Out45
L_I2C_LCD_Out46:
;LCD2x16_I2C.c,121 :: 		}
L_end_I2C_LCD_Out:
	RET
; end of _I2C_LCD_Out

_I2C_LCD_Out_Cp:

;LCD2x16_I2C.c,123 :: 		void I2C_LCD_Out_Cp(char *text) {
;LCD2x16_I2C.c,124 :: 		while(*text)
L_I2C_LCD_Out_Cp47:
	MOVW       R30, R2
	LD         R16, Z
	TST        R16
	BRNE       L__I2C_LCD_Out_Cp61
	JMP        L_I2C_LCD_Out_Cp48
L__I2C_LCD_Out_Cp61:
;LCD2x16_I2C.c,125 :: 		I2C_LCD_Chr_Cp(*text++);
	MOVW       R30, R2
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _I2C_LCD_Chr_Cp+0
	POP        R2
	POP        R3
	MOVW       R16, R2
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R2, R16
	JMP        L_I2C_LCD_Out_Cp47
L_I2C_LCD_Out_Cp48:
;LCD2x16_I2C.c,126 :: 		}
L_end_I2C_LCD_Out_Cp:
	RET
; end of _I2C_LCD_Out_Cp

LCD2x16_I2C____?ag:

L_end_LCD2x16_I2C___?ag:
	RET
; end of LCD2x16_I2C____?ag
